/*
 * Copyright (c) 2001,2002,2003 Mike Matsnev.  All Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice immediately at the beginning of the file, without modification,
 *    this list of conditions, and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Absolutely no warranty of function or purpose is made by the author
 *    Mike Matsnev.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * $Id: InputBox.h,v 1.9.2.2 2007/03/26 19:26:52 mike Exp $
 * 
 */

#if !defined(AFX_FINDDLG_H__09B31140_5147_46BC_8900_1BA21CA1C569__INCLUDED_)
#define AFX_FINDDLG_H__09B31140_5147_46BC_8900_1BA21CA1C569__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

// InputBox.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// InputBox dialog

class InputBox : public CDialog
{
// Construction
public:
  InputBox(const CString& prompt,const CString& title,
      CWnd* pParent = NULL);   // standard constructor
  
  // Dialog Data
  //{{AFX_DATA(InputBox)
  enum { IDD = IDD_FIND };
  CString	m_str;
  //}}AFX_DATA
  
  
  // Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(InputBox)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL
  
  // Implementation
protected:
  CString		m_prompt,m_title;
  // Generated message map functions
  //{{AFX_MSG(InputBox)
  virtual BOOL OnInitDialog();
  afx_msg void OnWordSetFocus();
  afx_msg void OnWordKillFocus();
  //}}AFX_MSG
  afx_msg void OnSettingChange(UINT uFlags,LPCTSTR lpszSection);
  DECLARE_MESSAGE_MAP()
};

bool	GetUserInput(const CString& prompt,const CString& title,
		     CString& def,CWnd *parent);

/////////////////////////////////////////////////////////////////////////////
// CAddBmDialog dialog

class CAddBmDialog : public CDialog
{
  // Construction
public:
  CAddBmDialog(CWnd* pParent = NULL);   // standard constructor
  
  // Dialog Data
  //{{AFX_DATA(CAddBmDialog)
  enum { IDD = IDD_ADDBMK };
  CString     m_text;
  //}}AFX_DATA
  

  // Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CAddBmDialog)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL
  
  // Implementation
protected:
  // Generated message map functions
  //{{AFX_MSG(CAddBmDialog)
  afx_msg void OnSetfocusBmkedit();
  afx_msg void OnKillfocusBmkedit();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// CFindDlg dialog

class CFindDlg : public CDialog
{
  // Construction
public:
  CFindDlg(CWnd* pParent = NULL);   // standard constructor
  
  // Dialog Data
  //{{AFX_DATA(CFindDlg)
  enum { IDD = IDD_FINDDLG };
  CString   m_text;
  BOOL	    m_matchcase;
  BOOL      m_fromcurpos;
  //}}AFX_DATA
  
  
  // Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(CFindDlg)
protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  //}}AFX_VIRTUAL
  
  // Implementation
protected:
  
  // Generated message map functions
  //{{AFX_MSG(CFindDlg)
	afx_msg void OnSetfocusFindtext();
	afx_msg void OnKillfocusFindtext();
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};
//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FINDDLG_H__09B31140_5147_46BC_8900_1BA21CA1C569__INCLUDED_)
